diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityBasket.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityBasket.java
index 1944ba820..be9c13798 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityBasket.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityBasket.java
@@ -33,7 +33,7 @@ public class TileEntityBasket extends TileEntity {
         int currentNumInside = calcNumUnitsInside();
         if (currentNumInside != numUnitsInside && worldObj != null) {
             this.numUnitsInside = currentNumInside;
-            worldObj.notifyBlockChange(x, y, z, worldObj.getBlockId(x, y, z));
+            worldObj.notifyBlockChange(tilePos.x, tilePos.y, tilePos.z, worldObj.getBlockId(tilePos.x, tilePos.y, tilePos.z));
             setChanged();
         }
     }
@@ -69,7 +69,7 @@ public class TileEntityBasket extends TileEntity {
             return;
         }
 
-        final EntityItem item = new EntityItem(workingWorld, this.x + f, this.y + f1, this.z + f2, itemstack);
+        final EntityItem item = new EntityItem(workingWorld, this.tilePos.x + f, this.tilePos.y + f1, this.tilePos.z + f2, itemstack);
         final float f3 = 0.05F;
         item.xd = (float) rand.nextGaussian() * f3;
         item.yd = (float) rand.nextGaussian() * f3 + 0.25F;
@@ -106,7 +106,7 @@ public class TileEntityBasket extends TileEntity {
         }
 
         updateNumUnits();
-        world.notifyBlockChange(this.x, this.y, this.z, Blocks.BASKET.id());
+        world.notifyBlockChange(this.tilePos.x, this.tilePos.y, this.tilePos.z, Blocks.BASKET.id());
     }
 
     @Override
@@ -133,9 +133,9 @@ public class TileEntityBasket extends TileEntity {
         final World workingWorld;
         if (this.worldObj != null) {
             workingWorld = this.worldObj;
-            posX = this.x;
-            posY = this.y;
-            posZ = this.z;
+            posX = this.tilePos.x;
+            posY = this.tilePos.y;
+            posZ = this.tilePos.z;
         } else if (this.carriedBlock != null) {
             workingWorld = this.carriedBlock.world;
             posX = this.carriedBlock.holder.x - 0.5;
@@ -167,7 +167,7 @@ public class TileEntityBasket extends TileEntity {
 
         if (shouldUpdate) {
             if (this.worldObj != null) {
-                this.worldObj.notifyBlockChange(this.x, this.y, this.z, Blocks.BASKET.id());
+                this.worldObj.notifyBlockChange(this.tilePos.x, this.tilePos.y, this.tilePos.z, Blocks.BASKET.id());
             }
             updateNumUnits();
         }
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityChest.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityChest.java
index 4b48855bf..3102e18bd 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityChest.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityChest.java
@@ -125,11 +125,11 @@ public class TileEntityChest extends TileEntity
     @Override
 	public boolean stillValid(@NotNull Player player)
     {
-        if(worldObj == null || worldObj.getTileEntity(x, y, z) != this)
+        if(worldObj == null || worldObj.getTileEntity(tilePos.x, tilePos.y, tilePos.z) != this)
         {
             return false;
         }
-        return player.distanceToSqr((double) x + 0.5D, (double) y + 0.5D, (double) z + 0.5D) <= 64D;
+        return player.distanceToSqr((double) tilePos.x + 0.5D, (double) tilePos.y + 0.5D, (double) tilePos.z + 0.5D) <= 64D;
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityDispatcher.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityDispatcher.java
index 3d141b458..6137d822f 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityDispatcher.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityDispatcher.java
@@ -87,6 +87,7 @@ public class TileEntityDispatcher {
         addMapping(TileEntitySeat.class, NamespaceID.fromPool("minecraft", "seat"));
         addMapping(TileEntityFlowerJar.class, NamespaceID.fromPool("minecraft", "jar_flower"));
         addMapping(TileEntityJarButterfly.class, NamespaceID.fromPool("minecraft", "jar_butterfly"));
+        addMapping(TileEntityMesh.class, NamespaceID.fromPool("minecraft", "mesh"));
         addMapping(TileEntityMeshGold.class, NamespaceID.fromPool("minecraft", "mesh_gold"));
         addMapping(TileEntityStatue.class, NamespaceID.fromPool("minecraft", "statue_stone"));
     }
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityDispenser.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityDispenser.java
index dd7fa3cd0..ffb16000b 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityDispenser.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityDispenser.java
@@ -171,11 +171,11 @@ public class TileEntityDispenser extends TileEntity
     @Override
 	public boolean stillValid(@NotNull Player player)
     {
-        if(worldObj == null || worldObj.getTileEntity(x, y, z) != this)
+        if(worldObj == null || worldObj.getTileEntity(tilePos.x, tilePos.y, tilePos.z) != this)
         {
             return false;
         }
-        return player.distanceToSqr((double) x + 0.5D, (double) y + 0.5D, (double) z + 0.5D) <= 64D;
+        return player.distanceToSqr((double) tilePos.x + 0.5D, (double) tilePos.y + 0.5D, (double) tilePos.z + 0.5D) <= 64D;
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFlag.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFlag.java
index 75eb6db52..ffeb31d92 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFlag.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFlag.java
@@ -265,11 +265,11 @@ public class TileEntityFlag extends TileEntity
     @Override
     public boolean stillValid(@NotNull Player player)
     {
-        if(worldObj == null || worldObj.getTileEntity(x, y, z) != this)
+        if(worldObj == null || worldObj.getTileEntity(tilePos.x, tilePos.y, tilePos.z) != this)
         {
             return false;
         }
-        return player.distanceToSqr((double) x + 0.5D, (double) y + 0.5D, (double) z + 0.5D) <= 64D;
+        return player.distanceToSqr((double) tilePos.x + 0.5D, (double) tilePos.y + 0.5D, (double) tilePos.z + 0.5D) <= 64D;
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFurnace.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFurnace.java
index 167b9015d..f2fab04d6 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFurnace.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFurnace.java
@@ -67,7 +67,7 @@ public class TileEntityFurnace extends TileEntity
                 ItemStack itemstack = furnaceItemStacks[slot];
                 furnaceItemStacks[slot] = null;
                 if (worldObj != null && slot == SLOT_RESULT) {
-                    worldObj.markBlockNeedsUpdate(x, y, z);
+                    worldObj.markBlockNeedsUpdate(tilePos.x, tilePos.y, tilePos.z);
                 }
                 return itemstack;
             }
@@ -76,7 +76,7 @@ public class TileEntityFurnace extends TileEntity
             {
                 furnaceItemStacks[slot] = null;
                 if (worldObj != null && slot == SLOT_RESULT) {
-                    worldObj.markBlockNeedsUpdate(x, y, z);
+                    worldObj.markBlockNeedsUpdate(tilePos.x, tilePos.y, tilePos.z);
                 }
             }
             return itemstack1;
@@ -95,7 +95,7 @@ public class TileEntityFurnace extends TileEntity
             stack.stackSize = getMaxStackSize();
         }
         if (worldObj != null && slot == SLOT_RESULT && stack == null) {
-            worldObj.markBlockNeedsUpdate(x, y, z);
+            worldObj.markBlockNeedsUpdate(tilePos.x, tilePos.y, tilePos.z);
         }
     }
 
@@ -183,7 +183,7 @@ public class TileEntityFurnace extends TileEntity
         }
         if(worldObj == null || !worldObj.isClientSide)
         {
-        	if(worldObj == null || worldObj.getBlockId(x, y, z) == Blocks.FURNACE_STONE_IDLE.id()) {
+        	if(worldObj == null || worldObj.getBlockId(tilePos.x, tilePos.y, tilePos.z) == Blocks.FURNACE_STONE_IDLE.id()) {
             	if(currentBurnTime == 0 && furnaceItemStacks[SLOT_INGREDIENT] == null) {
             		if(furnaceItemStacks[SLOT_FUEL] != null && furnaceItemStacks[SLOT_FUEL].itemID == Blocks.COBBLE_NETHERRACK.id()) {
             			furnaceItemStacks[SLOT_FUEL].stackSize--;
@@ -305,13 +305,13 @@ public class TileEntityFurnace extends TileEntity
             furnaceItemStacks[SLOT_INGREDIENT] = null;
         }
         if (worldObj != null && wasEmpty && furnaceItemStacks[SLOT_RESULT] != null) {
-            worldObj.markBlockNeedsUpdate(x, y, z);
+            worldObj.markBlockNeedsUpdate(tilePos.x, tilePos.y, tilePos.z);
         }
     }
 
     protected void updateFurnace(boolean forceLit){
         if (worldObj != null) {
-            BlockLogicFurnace.updateFurnaceBlockState(worldObj, new TilePos(x, y, z), forceLit | (currentBurnTime > 0));
+            BlockLogicFurnace.updateFurnaceBlockState(worldObj, tilePos, forceLit | (currentBurnTime > 0));
         } else if (carriedBlock != null) {
             carriedBlock.blockId = (forceLit | (currentBurnTime > 0)) ? Blocks.FURNACE_STONE_ACTIVE.id() : Blocks.FURNACE_STONE_IDLE.id();
         }
@@ -327,11 +327,11 @@ public class TileEntityFurnace extends TileEntity
     @Override
 	public boolean stillValid(@NotNull Player player)
     {
-        if(worldObj == null || worldObj.getTileEntity(x, y, z) != this)
+        if(worldObj == null || worldObj.getTileEntity(tilePos.x, tilePos.y, tilePos.z) != this)
         {
             return false;
         }
-        return player.distanceToSqr((double) x + 0.5D, (double) y + 0.5D, (double) z + 0.5D) <= 64D;
+        return player.distanceToSqr((double) tilePos.x + 0.5D, (double) tilePos.y + 0.5D, (double) tilePos.z + 0.5D) <= 64D;
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFurnaceBlast.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFurnaceBlast.java
index 92f9329b4..209aeb4bf 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFurnaceBlast.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFurnaceBlast.java
@@ -67,7 +67,7 @@ public class TileEntityFurnaceBlast extends TileEntity
                 final ItemStack itemstack = this.inventory[slot];
                 this.inventory[slot] = null;
                 if (this.worldObj != null && slot == SLOT_RESULT) {
-                    this.worldObj.markBlockNeedsUpdate(this.x, this.y, this.z);
+                    this.worldObj.markBlockNeedsUpdate(this.tilePos.x, this.tilePos.y, this.tilePos.z);
                 }
                 return itemstack;
             }
@@ -75,7 +75,7 @@ public class TileEntityFurnaceBlast extends TileEntity
             if (this.inventory[slot].stackSize <= 0) {
                 this.inventory[slot] = null;
                 if (this.worldObj != null && slot == SLOT_RESULT) {
-                    this.worldObj.markBlockNeedsUpdate(this.x, this.y, this.z);
+                    this.worldObj.markBlockNeedsUpdate(this.tilePos.x, this.tilePos.y, this.tilePos.z);
                 }
             }
             return itemstack1;
@@ -91,7 +91,7 @@ public class TileEntityFurnaceBlast extends TileEntity
             stack.stackSize = getMaxStackSize();
         }
         if (this.worldObj != null && slot == SLOT_RESULT && stack == null) {
-            this.worldObj.markBlockNeedsUpdate(this.x, this.y, this.z);
+            this.worldObj.markBlockNeedsUpdate(this.tilePos.x, this.tilePos.y, this.tilePos.z);
         }
     }
 
@@ -167,7 +167,7 @@ public class TileEntityFurnaceBlast extends TileEntity
             this.currentBurnTime--;
         }
         if (this.worldObj == null || !this.worldObj.isClientSide) {
-            if (this.worldObj == null || this.worldObj.getBlockId(this.x, this.y, this.z) == Blocks.FURNACE_BLAST_IDLE.id()) {
+            if (this.worldObj == null || this.worldObj.getBlockId(this.tilePos.x, this.tilePos.y, this.tilePos.z) == Blocks.FURNACE_BLAST_IDLE.id()) {
                 if (this.currentBurnTime == 0 && this.inventory[SLOT_LEFT] == null && this.inventory[SLOT_RIGHT] == null) {
                     if (this.inventory[SLOT_FUEL] != null && this.inventory[SLOT_FUEL].itemID == Blocks.COBBLE_NETHERRACK.id()) {
                         this.inventory[SLOT_FUEL].stackSize--;
@@ -273,7 +273,7 @@ public class TileEntityFurnaceBlast extends TileEntity
 
     protected void updateFurnace(final boolean forceLit) {
         if (this.worldObj != null) {
-            BlockLogicFurnaceBlast.updateFurnaceBlockState(this.worldObj, new TilePos(this.x, this.y, this.z), forceLit | (this.currentBurnTime > 0));
+            BlockLogicFurnaceBlast.updateFurnaceBlockState(this.worldObj, new TilePos(this.tilePos.x, this.tilePos.y, this.tilePos.z), forceLit | (this.currentBurnTime > 0));
         } else if (this.carriedBlock != null) {
             this.carriedBlock.blockId = (forceLit | (this.currentBurnTime > 0)) ? Blocks.FURNACE_BLAST_ACTIVE.id() : Blocks.FURNACE_BLAST_IDLE.id();
         }
@@ -287,10 +287,10 @@ public class TileEntityFurnaceBlast extends TileEntity
 
     @Override
     public boolean stillValid(final @NotNull Player player) {
-        if (this.worldObj == null || this.worldObj.getTileEntity(this.x, this.y, this.z) != this) {
+        if (this.worldObj == null || this.worldObj.getTileEntity(this.tilePos.x, this.tilePos.y, this.tilePos.z) != this) {
             return false;
         }
-        return player.distanceToSqr((double) this.x + 0.5D, (double) this.y + 0.5D, (double) this.z + 0.5D) <= 64D;
+        return player.distanceToSqr((double) this.tilePos.x + 0.5D, (double) this.tilePos.y + 0.5D, (double) this.tilePos.z + 0.5D) <= 64D;
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityMesh.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityMesh.java
new file mode 100644
index 000000000..68574af82
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityMesh.java
@@ -0,0 +1,266 @@
+package net.minecraft.core.block.entity;
+import com.mojang.nbt.tags.CompoundTag;
+import net.minecraft.core.achievement.Achievements;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.current.wire.WireHandler;
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.entity.EntityItem;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.util.helper.Axis;
+import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.world.pos.TilePos;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.joml.primitives.AABBd;
+import org.joml.primitives.AABBdc;
+
+import java.util.*;
+import java.util.stream.Collectors;
+
+public class TileEntityMesh extends TileEntity {
+    public final @NotNull List<EntityItem> trackedItemsSiphoning = new ArrayList<>(List.of());
+    public final int siphonWidth = 5;
+    public final int siphonHeight = 2;
+    public int ticksRan = 0;
+    public TileEntityMesh() {
+    }
+
+    @Override
+    public void tick()
+    {
+        if (this.worldObj == null || this.worldObj.isClientSide) {
+            return;
+        }
+
+        Map<Direction, Boolean> validSiphonDirections = Arrays.stream(WireHandler.Directions.ALL).collect(Collectors.toMap(direction -> direction, this::isValidWater));
+        handleSiphon(validSiphonDirections);
+
+        if (ticksRan == 0){
+            ticksRan = worldObj.rand.nextInt(360);
+        }
+        ticksRan++;
+    }
+
+    @Override
+    public void readAdditionalData(@NotNull CompoundTag compoundTag) {
+
+    }
+
+    @Override
+    public void writeAdditionalData(@NotNull CompoundTag compoundTag) {
+
+    }
+
+    protected void handleSiphon(@NotNull Map<Direction, Boolean> validSiphonDirections){
+        //null-checks were already made
+        assert this.worldObj != null;
+
+        Direction direction = getSingleValidFace(validSiphonDirections);
+        if(direction == Direction.NONE){return;}
+        AABBdc siphonBox = getSiphonBox(tilePos, direction);
+        List<Entity> entitiesWithinSiphonBox = this.worldObj.getEntitiesWithinAABBExcludingEntity(null, siphonBox);
+        removeTrackedItems(entitiesWithinSiphonBox);
+
+        for (Entity entity : entitiesWithinSiphonBox)
+        {
+            if (entity instanceof EntityItem item && entity.isInWater())
+            {
+                if(item.meshSiphoning == null && item.siphonDirection == Direction.NONE){
+                    item.siphonDirection = direction.getOpposite();
+                    item.meshSiphoning = this;
+                }
+
+                if(direction.getOpposite().equals(item.siphonDirection) && item.meshSiphoning == this){
+
+                    Player player = entity.world.getClosestPlayer(tilePos.x, tilePos.y, tilePos.z, 12);
+                    if(player != null) {
+                        player.triggerAchievement(Achievements.DOWN_THE_DRAIN);
+                    }
+
+                    siphonItemIntoBlock(item, direction);
+                    addItemsToBeTracked(item);
+                }
+            }
+        }
+    }
+
+    protected void removeTrackedItems(@NotNull List<Entity> entitiesWithinSiphonBox){
+        Iterator<EntityItem> iterator = trackedItemsSiphoning.iterator();
+        while (iterator.hasNext()) {
+            EntityItem item = iterator.next();
+            if (!entitiesWithinSiphonBox.contains(item)) {
+                item.siphonDirection = Direction.NONE;
+                item.meshSiphoning = null;
+                iterator.remove();
+                break;
+            }
+        }
+    }
+
+    protected void addItemsToBeTracked(@NotNull EntityItem item){
+        if(!trackedItemsSiphoning.contains(item))
+            trackedItemsSiphoning.add((item));
+    }
+
+    protected @NotNull Direction getSingleValidFace(@NotNull Map<Direction, Boolean> validSiphonDirections){
+        //If none are valid or if more than one side is valid, returns Direction.NONE
+        //else, returns the valid Direction
+
+        Direction direction = Direction.NONE;
+
+        if(validSiphonDirections.values().stream().noneMatch(val -> val) ||
+        validSiphonDirections.values().stream().filter(val -> val).count() > 1) {
+            return direction;
+        }
+
+        for (Map.Entry<Direction, Boolean> entry : validSiphonDirections.entrySet()) {
+            if (entry.getValue()) {
+                direction = entry.getKey();
+                break;
+            }
+        }
+
+        if (direction == Direction.DOWN){
+            return Direction.NONE;
+        }
+
+        return direction;
+    }
+
+    protected AABBdc getSiphonBox(TilePos tilePos, @NotNull Direction facing){
+        // get the center of the block
+        double centerX = tilePos.x + 0.5;
+        double centerY = tilePos.y + 0.5;
+        double centerZ = tilePos.z + 0.5;
+
+        // move the center to the edge of the block face
+        centerX += facing.getOffsetX() * 0.5;
+        centerY += facing.getOffsetY() * 0.5;
+        centerZ += facing.getOffsetZ() * 0.5;
+
+        // move height distance further in the facing direction
+        double farX = centerX + (facing.getOffsetX() * siphonHeight);
+        double farY = centerY + (facing.getOffsetY() * siphonHeight);
+        double farZ = centerZ + (facing.getOffsetZ() * siphonHeight);
+
+
+        // need a half width since in middle of block
+        double hw = siphonWidth / 2.0;
+
+        // expand/inflate
+        // (would be amazing if AABBd had .inflate(), but we are decrepit old bastards don't even get me started on the mental processing it took to work on this shitty ass code for the first time I need sleep and want to die)
+        double minX = Math.min(centerX, farX);
+        double minY = Math.min(centerY, farY);
+        double minZ = Math.min(centerZ, farZ);
+
+        double maxX = Math.max(centerX, farX);
+        double maxY = Math.max(centerY, farY);
+        double maxZ = Math.max(centerZ, farZ);
+
+        // expand based on the axis we are NOT facing
+        if (facing.getAxis() != Axis.X) {
+            minX -= hw;
+            maxX += hw;
+        }
+        if (facing.getAxis() != Axis.Y) {
+            minY -= hw;
+            maxY += hw;
+        }
+        if (facing.getAxis() != Axis.Z) {
+            minZ -= hw;
+            maxZ += hw;
+        }
+
+        //yay we returned it goodnight sleep tight I need food
+        return new AABBd(minX, minY, minZ, maxX, maxY, maxZ);
+    }
+
+    protected void siphonItemIntoBlock(@NotNull EntityItem item, @NotNull Direction direction){
+
+        double targetX = this.tilePos.x + 0.5;
+        double targetY = this.tilePos.y + 0.5;
+        double targetZ = this.tilePos.z + 0.5;
+
+        //difference vectors
+        double diffX = targetX - item.x;
+        double diffY = targetY - item.y;
+        double diffZ = targetZ - item.z;
+
+        //distance from item
+        double dist = Math.sqrt(diffX * diffX + diffY * diffY + diffZ * diffZ);
+
+        //we don't divide by zero in this household
+        if (dist > 0.01) {
+
+            //Siphon variables yippee!!!!
+            double maxRange         = Math.max(siphonWidth / 2.0, siphonHeight);
+            double clampedDist      = Math.min(dist, maxRange);
+            double proximityFactor  = 1.0 + (maxRange / (clampedDist + 0.5));
+            double pullStrength     = 0.05;
+            double dynSwirlStrength = (pullStrength * 1.5) * proximityFactor;
+
+            /*
+            //normalize the pull speed and apply the dynamic speed multiplier
+            double pullX = (diffX / dist) * speedMultiplier;
+            double pullY = (diffY / dist) * speedMultiplier;
+            double pullZ = (diffZ / dist) * speedMultiplier;
+            */
+
+            //non-normalize implementation
+            double speedMultiplier  = pullStrength * proximityFactor;
+            double pullX = diffX  * speedMultiplier;
+            double pullY = diffY  * speedMultiplier;
+            double pullZ = diffZ  * speedMultiplier;
+
+            //axis check to make sure the swirl behaves correctly depending on facing direction
+            double sX = 0, sY = 0, sZ = 0;
+            if (direction.getAxis() == Axis.Y) {
+                sX = -diffZ;
+                sZ = diffX;
+            } else if (direction.getAxis() == Axis.Z) {
+                sX = -diffY;
+                sY = diffX;
+            } else {
+                sY = -diffZ;
+                sZ = diffY;
+            }
+
+            double swirlDist = Math.sqrt(sX * sX + sY * sY + sZ * sZ);
+            if (swirlDist > 0.01) {
+                // swirl also gets faster as it gets closer
+                sX = (sX / swirlDist) * dynSwirlStrength;
+                sY = (sY / swirlDist) * dynSwirlStrength;
+                sZ = (sZ / swirlDist) * dynSwirlStrength;
+            }
+
+            item.xd = pullX + sX;
+            item.yd = pullY + sY;
+            item.zd = pullZ + sZ;
+
+            //kinda gave up here, don't know what I was on but it kinda works so..?
+            double slowStrength = 0.5 - (0.2 * (1.0 - (clampedDist / maxRange)));
+            switch (direction) {
+                case UP    -> {if (item.yd < 0) item.yd *= slowStrength;}
+                case DOWN  -> {if (item.yd > 0) item.yd *= slowStrength;}
+                case NORTH -> {if (item.zd > 0) item.zd *= slowStrength;}
+                case SOUTH -> {if (item.zd < 0) item.zd *= slowStrength;}
+                case WEST  -> {if (item.xd > 0) item.xd *= slowStrength;}
+                case EAST  -> {if (item.xd < 0) item.xd *= slowStrength;}
+            }
+        }
+    }
+
+    protected boolean isValidWater(@NotNull Direction direction){
+        if(worldObj == null){
+            return false;
+        }
+
+        //check both if block in 'direction' is water, and if it is a full block of water
+        if(worldObj.getBlockType(new TilePos(tilePos).add(direction)) == Blocks.FLUID_WATER_STILL){
+            return !Blocks.FLUID_WATER_STILL.getLogic().hasFlowVector(worldObj, new TilePos(tilePos).add(direction));
+        }
+        return false;
+    }
+
+}
+
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityMeshGold.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityMeshGold.java
index d5564e64c..c3fe1a39a 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityMeshGold.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityMeshGold.java
@@ -1,30 +1,69 @@
 package net.minecraft.core.block.entity;
 
 import com.mojang.nbt.tags.CompoundTag;
+import net.minecraft.core.achievement.Achievements;
+import net.minecraft.core.current.wire.WireHandler;
+import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityItem;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.net.packet.Packet;
 import net.minecraft.core.net.packet.PacketTileEntityData;
+import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.primitives.AABBdc;
 
-public class TileEntityMeshGold extends TileEntity {
+import java.util.Arrays;
+import java.util.List;
+import java.util.Map;
+import java.util.stream.Collectors;
+
+public class TileEntityMeshGold extends TileEntityMesh {
     @Nullable
     public ItemStack filterItem;
     public int ticksRan = 0;
     public TileEntityMeshGold() {
     }
 
+    @Override
     public void tick()
     {
+        if (this.worldObj == null || this.worldObj.isClientSide) {
+            return;
+        }
+
+        if(filterItem != null){
+            Map<Direction, Boolean> validSiphonDirections = Arrays.stream(WireHandler.Directions.ALL).collect(Collectors.toMap(direction -> direction, this::isValidWater));
+            handleSiphon(validSiphonDirections);
+        }
+
         if (ticksRan == 0){
             ticksRan = worldObj.rand.nextInt(360);
         }
         ticksRan++;
     }
 
+    @Override
+    public void readAdditionalData(@NotNull CompoundTag compoundTag)
+    {
+        if (compoundTag.getBoolean("hasItem")){
+            filterItem = ItemStack.readItemStackFromNbt(compoundTag.getCompound("item"));
+        } else {
+            filterItem = null;
+        }
+    }
+
+    @Override
+    public void writeAdditionalData(@NotNull CompoundTag compoundTag)
+    {
+        if (filterItem != null){
+            compoundTag.putCompound("item", filterItem.writeToNBT(new CompoundTag()));
+            compoundTag.putBoolean("hasItem", true);
+        }
+    }
+
     public boolean setFilterItem(Player player, @Nullable ItemStack stack){
         boolean success = false;
         boolean wasNull = filterItem == null;
@@ -45,22 +84,40 @@ public class TileEntityMeshGold extends TileEntity {
         setChanged();
         return success | !wasNull;
     }
-    @Override
-    public void readAdditionalData(@NotNull CompoundTag compoundTag)
-    {
-        if (compoundTag.getBoolean("hasItem")){
-            filterItem = ItemStack.readItemStackFromNbt(compoundTag.getCompound("item"));
-        } else {
-            filterItem = null;
-        }
-    }
 
     @Override
-    public void writeAdditionalData(@NotNull CompoundTag compoundTag)
-    {
-        if (filterItem != null){
-            compoundTag.putCompound("item", filterItem.writeToNBT(new CompoundTag()));
-            compoundTag.putBoolean("hasItem", true);
+    protected void handleSiphon(@NotNull Map<Direction, Boolean> validSiphonDirections){
+        //null-checks were already made
+        assert this.worldObj != null;
+        assert this.filterItem != null;
+
+        Direction direction = getSingleValidFace(validSiphonDirections);
+        if(direction == Direction.NONE){return;}
+        AABBdc siphonBox = getSiphonBox(tilePos, direction);
+        List<Entity> entitiesWithinSiphonBox = this.worldObj.getEntitiesWithinAABBExcludingEntity(null, siphonBox);
+        removeTrackedItems(entitiesWithinSiphonBox);
+
+        for (Entity entity : entitiesWithinSiphonBox)
+        {
+            if (entity instanceof EntityItem item && entity.isInWater())
+            {
+                if(item.meshSiphoning == null && item.siphonDirection == Direction.NONE){
+                    item.siphonDirection = direction.getOpposite();
+                    item.meshSiphoning = this;
+                }
+                if(direction.getOpposite().equals(item.siphonDirection) && item.meshSiphoning == this) {
+                    if (item.item.getItem() == this.filterItem.getItem() && item.item.getMetadata() == this.filterItem.getMetadata()) {
+
+                        Player player = entity.world.getClosestPlayer(tilePos.x, tilePos.y, tilePos.z, 12);
+                        if(player != null) {
+                            player.triggerAchievement(Achievements.DOWN_THE_DRAIN);
+                        }
+
+                        siphonItemIntoBlock(item, direction);
+                        addItemsToBeTracked(item);
+                    }
+                }
+            }
         }
     }
 
